Imports CrystalDecisions.ReportAppServer.DataDefModel
Imports CrystalDecisions.CrystalReports.Engine
Imports System.Data
Public Class frmRasConnectionInfo
    Private boReportDocument As New ReportDocument
    Private Sub btnLoadReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadReport.Click
        With OpenFileDialog1
            .Filter = "Crystal Reports | *.rpt"
            .FileName = ""
            .InitialDirectory = Application.StartupPath
            .ShowDialog()
            If Not Trim(.FileName) = "" Then
                boReportDocument.Load(.FileName)
                txtVBCode.Text = ""
                txtCSCode.Text = ""
                VBConnectionCode(boReportDocument)
                CSConnectionCode(boReportDocument)
            End If
        End With

    End Sub

    Private Sub VBConnectionCode(ByVal boReportDocument As ReportDocument)
        Dim strCode(100) As String
        Dim i As Integer = 0
        Dim crTbl As CrystalDecisions.ReportAppServer.DataDefModel.Table
        crTbl = boReportDocument.ReportClientDocument.DatabaseController.Database.Tables(0)

        strCode(i) = "'Add these required Crystal Assemblies to your project"
        i += 1
        strCode(i) = "CrystalDecisions.ReportAppServer.DataDefModel"
        i += 1
        strCode(i) = "CrystalDecisions.ReportAppServer.ClientDoc"
        i += 1
        strCode(i) = "CrystalDecisions.ReportAppServer.Controllers"
        i += 1
        strCode(i) = "CrystalDecisions.CrystalReports.Engine"
        i += 1
        strCode(i) = "CrystalDecisions.Shared"
        i += 1
        strCode(i) = ""
        i += 1

        strCode(i) = "'Add these Crystal Assemblies to the top of your code page"
        i += 1
        strCode(i) = "Imports CrystalDecisions.ReportAppServer.DataDefModel"
        i += 1
        strCode(i) = "Imports CrystalDecisions.CrystalReports.Engine"
        i += 1
        strCode(i) = "Imports CrystalDecisions.Shared"
        i += 1
        strCode(i) = ""
        i += 1
        strCode(i) = "Public Function ChangeConnectionInfo() as ReportDocument"
        i += 1
        strCode(i) = "Dim boReportDocument as New ReportDocument"
        i += 1
        strCode(i) = "'**EDIT** Change the path and report name to the report you want to change."
        i += 1
        strCode(i) = "boReportDocument.Load(" + Chr(34) + "c:\reports\yourreport.rpt" + Chr(34) + ", OpenReportMethod.OpenReportByTempCopy)"
        i += 1
        strCode(i) = ""
        'Add code based on the class of table in the report.
        Select Case crTbl.ClassName
            Case "CrystalReports.Procedure"
                i += 1
                strCode(i) = "'Create a new Stored Procedure Table to replace the reports current table."
                i += 1
                strCode(i) = "Dim boTable As New CrystalDecisions.ReportAppServer.DataDefModel.Procedure"
            Case "CrystalReports.CommandTable"
                i += 1
                strCode(i) = "'Create a new Command Table to replace the reports current table."
                i += 1
                strCode(i) = "Dim boTable As New CrystalDecisions.ReportAppServer.DataDefModel.CommandTable"
            Case "CrystalReports.Table"
                i += 1
                strCode(i) = "'Create a new Database Table to replace the reports current table."
                i += 1
                strCode(i) = "Dim boTable As New CrystalDecisions.ReportAppServer.DataDefModel.Table"
        End Select
        i += 1
        strCode(i) = "  "
        i += 1
        strCode(i) = "'boMainPropertyBag: These hold the attributes of the tables ConnectionInfo object"
        i += 1
        strCode(i) = "Dim boMainPropertyBag As New PropertyBag"
        i += 1
        strCode(i) = "'boInnerPropertyBag: These hold the attributes for the QE_LogonProperties"
        i += 1
        strCode(i) = "'In the main property bag (boMainPropertyBag)"
        i += 1
        strCode(i) = "Dim boInnerPropertyBag As New PropertyBag"
        i += 1
        strCode(i) = "  "
        i += 1
        strCode(i) = "'Set the attributes for the boInnerPropertyBag"

        Dim crCi As CrystalDecisions.ReportAppServer.DataDefModel.ConnectionInfo
        crCi = crTbl.ConnectionInfo
        Dim boMainPropertyBag As PropertyBag = crCi.Attributes
        Dim boInnerPropertyBag As PropertyBag = boMainPropertyBag.Item("QE_LogonProperties")
        Dim propIDs As Strings
        propIDs = boInnerPropertyBag.PropertyIDs
        Dim propID As String
        For Each propID In propIDs
            i += 1
            strCode(i) = "boInnerPropertyBag.Add(" + Chr(34) + propID + Chr(34) + _
            ", " + Chr(34) + boInnerPropertyBag(propID).ToString + Chr(34) + ")"
        Next
        i += 1
        strCode(i) = "  "
        i += 1
        strCode(i) = "'Set the attributes for the boMainPropertyBag"
        propIDs = boMainPropertyBag.PropertyIDs
        Dim strVarName As String = "boInnerPropertyBag"
        For Each propID In propIDs
            i += 1
            If propID = "QE_LogonProperties" Then
                strCode(i) = "'Add the QE_LogonProperties we set in the boInnerPropertyBag Object"
                i += 1
                strCode(i) = "boMainPropertyBag.Add(" + Chr(34) + propID + Chr(34) + ", boInnerPropertyBag)"
            Else
                strCode(i) = "boMainPropertyBag.Add(" + Chr(34) + propID + Chr(34) + _
                ", " + Chr(34) + boMainPropertyBag(propID).ToString + Chr(34) + ")"
            End If
        Next
        i += 1
        strCode(i) = ""
        i += 1
        strCode(i) = "'Create a new ConnectionInfo object"
        i += 1
        strCode(i) = "Dim boConnectionInfo As New CrystalDecisions.ReportAppServer.DataDefModel.ConnectionInfo"
        i += 1
        strCode(i) = "'Pass the database properties to a connection info object"
        i += 1
        strCode(i) = "boConnectionInfo.Attributes = boMainPropertyBag"
        i += 1
        strCode(i) = "'Set the connection kind"
        i += 1
        strCode(i) = "boConnectionInfo.Kind = " + "CrConnectionInfoKindEnum." + crTbl.ConnectionInfo.Kind.ToString
        i += 1
        strCode(i) = "'**EDIT** Set the User Name and Password if required."
        i += 1
        strCode(i) = "boConnectionInfo.UserName = " + Chr(34) + "UserName" + Chr(34)
        i += 1
        strCode(i) = "boConnectionInfo.Password = " + Chr(34) + "Password" + Chr(34)
        i += 1
        strCode(i) = "'Pass the connection information to the table"
        i += 1
        strCode(i) = "boTable.ConnectionInfo = boConnectionInfo"
        i += 1
        strCode(i) = ""
        i += 1
        strCode(i) = "'Get the Database Tables Collection for your report"
        i += 1
        strCode(i) = "Dim boTables As CrystalDecisions.ReportAppServer.DataDefModel.Tables = _"
        i += 1
        strCode(i) = "boReportDocument.ReportClientDocument.DatabaseController.Database.Tables"
        i += 1
        strCode(i) = ""
        i += 1
        strCode(i) = "'For each table in the report:"
        i += 1
        strCode(i) = "' - Set the Table Name properties."
        If crTbl.ClassName = "CrystalReports.CommandTable" Then
            i += 1
            strCode(i) = "' - Set the Command table's command text."
        End If
        i += 1
        strCode(i) = "' - Set the table location in the report to use the new modified table"
        Dim itbl As Integer = 0
        For Each crTbl In boReportDocument.ReportClientDocument.DatabaseController.Database.Tables
            i += 1
            strCode(i) = "boTable.Name = " + Chr(34) + crTbl.Name + Chr(34)
            i += 1
            strCode(i) = "boTable.QualifiedName = " + Chr(34) + crTbl.QualifiedName + Chr(34)
            i += 1
            strCode(i) = "boTable.Alias = " + Chr(34) + crTbl.Alias + Chr(34)
            If crTbl.ClassName = "CrystalReports.CommandTable" Then
                i += 1
                strCode(i) = ""
                i += 1
                strCode(i) = "boTable.CommandText = " + Chr(34) + GetCommandTextVB(crTbl)
            End If
            i += 1
            strCode(i) = ""
            i += 1
            strCode(i) = "boReportDocument.ReportClientDocument.DatabaseController.SetTableLocation(boTables(" _
            + itbl.ToString + "), boTable)"
            i += 1
            strCode(i) = ""
            itbl += 1
        Next

        i += 1
        strCode(i) = "'Verify the database after adding substituting the new table."
        i += 1
        strCode(i) = "'To ensure that the table updates properly when adding Command tables or Stored Procedures."
        i += 1
        strCode(i) = "boReportDocument.VerifyDatabase()"


        If crTbl.ClassName = "CrystalReports.Procedure" Then
            i += 1
            strCode(i) = ""
            i += 1
            strCode(i) = "'**EDIT** Set the value for the Stored Procedure parameters."
            Dim crParam As CrystalDecisions.Shared.ParameterField
            For Each crParam In boReportDocument.ParameterFields
                If crParam.ReportParameterType = CrystalDecisions.Shared.ParameterType.StoreProcedureParameter Then
                    i += 1
                    strCode(i) = "boReportDocument.SetParameterValue(" + Chr(34) + crParam.Name + Chr(34) _
                    + ", " + Chr(34) + "Parameter Value" + Chr(34) + ")"
                End If
            Next
        End If
        i += 1
        strCode(i) = ""
        i += 1
        strCode(i) = "Return boReportDocument"
        i += 1
        strCode(i) = "End Function"
        ReDim Preserve strCode(i + 1)
        txtVBCode.Lines = strCode

    End Sub

    Private Function GetCommandTextVB(ByVal cmTbl As CommandTable) As String
        Dim strCmd1 As String = ""
        Dim strCmd2 As String = ""
        Dim iStart As Integer = 0
        Dim iLength As Integer = 50

        strCmd1 = cmTbl.CommandText.Trim()
        strCmd1 = strCmd1.Replace(Chr(13) + Chr(10), " ")
        If strCmd1.Contains(Chr(34)) Then
            If strCmd1.EndsWith(Chr(34)) Then
                strCmd1 = strCmd1.Remove(strCmd1.Length - 1, 1)
                strCmd1 = strCmd1.Replace(Chr(34), Chr(34) + " + Chr(34) + " + Chr(34))
                strCmd1 += Chr(34) + " + Chr(34)"
            Else
                strCmd1 = strCmd1.Replace(Chr(34), Chr(34) + " + Chr(34) + " + Chr(34))
            End If
        End If

        If strCmd1.Length > 100 Then
            For i As Integer = 0 To System.Math.Round(strCmd1.Length / 50) - 1
                If strCmd1.Contains(Chr(34)) Then
                    iLength = strCmd1.IndexOf(" + Chr(34) + ", iLength + 1) + 12
                    strCmd2 += strCmd1.Substring(iStart, iLength - iStart + 1) + Chr(95) + Chr(13) + Chr(10)
                    iStart = iLength + 1
                    iLength += 50
                Else
                    iLength = strCmd1.IndexOf(Chr(32), iLength + 1)
                    strCmd2 += strCmd1.Substring(iStart, iLength - iStart + 1) + Chr(34) + " + " _
                    + Chr(95) + Chr(13) + Chr(10) + Chr(34)
                    iStart = iLength + 1
                    iLength += 50
                End If
                
                If strCmd1.Length - iLength <= 50 Then
                    If strCmd1.EndsWith(")") Then
                        strCmd2 += strCmd1.Substring(iStart, strCmd1.Length - iStart)
                    Else
                        strCmd2 += strCmd1.Substring(iStart, strCmd1.Length - iStart) + Chr(34)
                    End If
                    Exit For
                End If
            Next
        Else
            If strCmd1.EndsWith("chr(34)") Then
                strCmd2 = strCmd1
            Else
                strCmd2 = strCmd1 + Chr(34)
            End If
        End If

        Return strCmd2
    End Function

    Private Sub CSConnectionCode(ByVal boReportDocument As ReportDocument)
        Dim strCode(100) As String
        Dim i As Integer = 0
        Dim crTbl As CrystalDecisions.ReportAppServer.DataDefModel.Table
        crTbl = boReportDocument.ReportClientDocument.DatabaseController.Database.Tables(0)

        strCode(i) = "//Add these required Crystal Assemblies to your project"
        i += 1
        strCode(i) = "CrystalDecisions.ReportAppServer.DataDefModel"
        i += 1
        strCode(i) = "CrystalDecisions.ReportAppServer.ClientDoc"
        i += 1
        strCode(i) = "CrystalDecisions.ReportAppServer.Controllers"
        i += 1
        strCode(i) = "CrystalDecisions.CrystalReports.Engine"
        i += 1
        strCode(i) = "CrystalDecisions.Shared"
        i += 1
        strCode(i) = ""
        i += 1
        strCode(i) = "//Add these Crystal Assemblies to the top of your code page"
        i += 1
        strCode(i) = "using CrystalDecisions.ReportAppServer.DataDefModel;"
        i += 1
        strCode(i) = "using CrystalDecisions.CrystalReports.Engine;"
        i += 1
        strCode(i) = "using CrystalDecisions.Shared;"
        i += 1
        strCode(i) = ""
        i += 1
        strCode(i) = "private ReportDocument ChangeConnectionInfo()"
        i += 1
        strCode(i) = "{"
        i += 1
        strCode(i) = "ReportDocument boReportDocument = new ReportDocument();"
        i += 1
        strCode(i) = "//**EDIT** Change the path and report name to the report you want to change."
        i += 1
        strCode(i) = "boReportDocument.Load(@" + Chr(34) + "c:\reports\yourreport.rpt" + Chr(34) + ", OpenReportMethod.OpenReportByTempCopy);"
        i += 1
        strCode(i) = ""
        'Add code based on the class of table in the report.
        Select Case crTbl.ClassName
            Case "CrystalReports.Procedure"
                i += 1
                strCode(i) = "//Create a new Stored Procedure Table to replace the reports current table."
                i += 1
                strCode(i) = "CrystalDecisions.ReportAppServer.DataDefModel.Procedure boTable = "
                i += 1
                strCode(i) = "new CrystalDecisions.ReportAppServer.DataDefModel.Procedure();"
            Case "CrystalReports.CommandTable"
                i += 1
                strCode(i) = "//Create a new Command Table to replace the reports current table."
                i += 1
                strCode(i) = "CrystalDecisions.ReportAppServer.DataDefModel.CommandTable boTable = "
                i += 1
                strCode(i) = "new CrystalDecisions.ReportAppServer.DataDefModel.CommandTable();"

            Case "CrystalReports.Table"
                i += 1
                strCode(i) = "//Create a new Database Table to replace the reports current table."
                i += 1
                strCode(i) = "CrystalDecisions.ReportAppServer.DataDefModel.Table boTable = "
                i += 1
                strCode(i) = "new CrystalDecisions.ReportAppServer.DataDefModel.Table();"
        End Select
        i += 1
        strCode(i) = "  "
        i += 1
        strCode(i) = "//boMainPropertyBag: These hold the attributes of the tables ConnectionInfo object"
        i += 1
        strCode(i) = "PropertyBag boMainPropertyBag = new PropertyBag();"
        i += 1
        strCode(i) = "//boInnerPropertyBag: These hold the attributes for the QE_LogonProperties"
        i += 1
        strCode(i) = "//In the main property bag (boMainPropertyBag)"
        i += 1
        strCode(i) = "PropertyBag boInnerPropertyBag = new PropertyBag();"
        i += 1
        strCode(i) = "  "
        i += 1
        strCode(i) = "//Set the attributes for the boInnerPropertyBag"

        Dim crCi As CrystalDecisions.ReportAppServer.DataDefModel.ConnectionInfo
        crCi = crTbl.ConnectionInfo
        Dim boMainPropertyBag As PropertyBag = crCi.Attributes
        Dim boInnerPropertyBag As PropertyBag = boMainPropertyBag.Item("QE_LogonProperties")
        Dim propIDs As Strings
        propIDs = boInnerPropertyBag.PropertyIDs
        Dim propID As String
        For Each propID In propIDs
            i += 1
            strCode(i) = "boInnerPropertyBag.Add(" + Chr(34) + propID + Chr(34) + ", "
            If boInnerPropertyBag(propID).ToString.LastIndexOf("\") > 0 Then
                strCode(i) += "@"
            End If
            strCode(i) += Chr(34) + boInnerPropertyBag(propID).ToString + Chr(34) + ");"
        Next
        i += 1
        strCode(i) = "  "
        i += 1
        strCode(i) = "//Set the attributes for the boMainPropertyBag"
        propIDs = boMainPropertyBag.PropertyIDs
        Dim strVarName As String = "boInnerPropertyBag"
        For Each propID In propIDs
            i += 1
            If propID = "QE_LogonProperties" Then
                strCode(i) = "//Add the QE_LogonProperties we set in the boInnerPropertyBag Object"
                i += 1
                strCode(i) = "boMainPropertyBag.Add(" + Chr(34) + propID + Chr(34) + ", boInnerPropertyBag);"
            Else
                strCode(i) = "boMainPropertyBag.Add(" + Chr(34) + propID + Chr(34) + ", "
                If boMainPropertyBag(propID).ToString.LastIndexOf("\") > 0 Then
                    strCode(i) += "@"
                End If
                strCode(i) += Chr(34) + boMainPropertyBag(propID).ToString + Chr(34) + ");"
            End If
        Next
        i += 1
        strCode(i) = ""
        i += 1
        strCode(i) = "//Create a new ConnectionInfo object"
        i += 1
        strCode(i) = "CrystalDecisions.ReportAppServer.DataDefModel.ConnectionInfo boConnectionInfo = "
        i += 1
        strCode(i) = "new CrystalDecisions.ReportAppServer.DataDefModel.ConnectionInfo();"
        i += 1
        strCode(i) = "//Pass the database properties to a connection info object"
        i += 1
        strCode(i) = "boConnectionInfo.Attributes = boMainPropertyBag;"
        i += 1
        strCode(i) = "//Set the connection kind"
        i += 1
        strCode(i) = "boConnectionInfo.Kind = " + "CrConnectionInfoKindEnum." + crTbl.ConnectionInfo.Kind.ToString + ";"
        i += 1
        strCode(i) = "//**EDIT** Set the User Name and Password if required."
        i += 1
        strCode(i) = "boConnectionInfo.UserName = " + Chr(34) + "UserName" + Chr(34) + ";"
        i += 1
        strCode(i) = "boConnectionInfo.Password = " + Chr(34) + "Password" + Chr(34) + ";"
        i += 1
        strCode(i) = "//Pass the connection information to the table"
        i += 1
        strCode(i) = "boTable.ConnectionInfo = boConnectionInfo;"
        i += 1
        strCode(i) = ""
        i += 1
        strCode(i) = "//Get the Database Tables Collection for your report"
        i += 1
        strCode(i) = "CrystalDecisions.ReportAppServer.DataDefModel.Tables boTables;"
        i += 1
        strCode(i) = "boTables = boReportDocument.ReportClientDocument.DatabaseController.Database.Tables;"
        i += 1
        strCode(i) = ""
        i += 1
        strCode(i) = "//For each table in the report:"
        i += 1
        strCode(i) = "// - Set the Table Name properties."
        If crTbl.ClassName = "CrystalReports.CommandTable" Then
            i += 1
            strCode(i) = "// - Set the Command table's command text."
        End If
        i += 1
        strCode(i) = "// - Set the table location in the report to use the new modified table"
        Dim itbl As Integer = 0
        For Each crTbl In boReportDocument.ReportClientDocument.DatabaseController.Database.Tables
            i += 1
            strCode(i) = "boTable.Name = " + Chr(34) + crTbl.Name + Chr(34) + ";"
            i += 1
            strCode(i) = "boTable.QualifiedName = " + Chr(34) + crTbl.QualifiedName + Chr(34) + ";"
            i += 1
            strCode(i) = "boTable.Alias = " + Chr(34) + crTbl.Alias + Chr(34) + ";"
            If crTbl.ClassName = "CrystalReports.CommandTable" Then
                i += 1
                strCode(i) = ""
                i += 1
                strCode(i) = "boTable.CommandText = " + Chr(34) + GetCommandTextCS(crTbl)
            End If
            i += 1
            strCode(i) = ""
            i += 1
            strCode(i) = "boReportDocument.ReportClientDocument.DatabaseController.SetTableLocation(boTables[" _
            + itbl.ToString + "], boTable);"
            i += 1
            strCode(i) = ""
            itbl += 1
        Next

        i += 1
        strCode(i) = "//Verify the database after adding substituting the new table."
        i += 1
        strCode(i) = "//To ensure that the table updates properly when adding Command tables or Stored Procedures."
        i += 1
        strCode(i) = "boReportDocument.VerifyDatabase();"


        If crTbl.ClassName = "CrystalReports.Procedure" Then
            i += 1
            strCode(i) = ""
            i += 1
            strCode(i) = "//**EDIT** Set the value for the Stored Procedure parameters."
            Dim crParam As CrystalDecisions.Shared.ParameterField
            For Each crParam In boReportDocument.ParameterFields
                If crParam.ReportParameterType = CrystalDecisions.Shared.ParameterType.StoreProcedureParameter Then
                    i += 1
                    strCode(i) = "boReportDocument.SetParameterValue(" + Chr(34) + crParam.Name + Chr(34) _
                    + ", " + Chr(34) + "Parameter Value" + Chr(34) + ");"
                End If
            Next
        End If
        i += 1
        strCode(i) = ""
        i += 1
        strCode(i) = "return boReportDocument;"
        i += 1
        strCode(i) = "}"
        ReDim Preserve strCode(i + 1)
        txtCSCode.Lines = strCode
    End Sub

    Private Function GetCommandTextCS(ByVal cmTbl As CommandTable) As String
        Dim strCmd1 As String = ""
        Dim strCmd2 As String = ""
        Dim iStart As Integer = 0
        Dim iLength As Integer = 50

        strCmd1 = cmTbl.CommandText.Trim()
        strCmd1 = strCmd1.Replace(Chr(13) + Chr(10), " ")
        If strCmd1.Contains(Chr(34)) Then
            If strCmd1.EndsWith(Chr(34)) Then
                strCmd1 = strCmd1.Remove(strCmd1.Length - 1, 1)
                strCmd1 = strCmd1.Replace(Chr(34), Chr(34) + " + (char)34 + " + Chr(34))
                strCmd1 += Chr(34) + " + (char)34"
            Else
                strCmd1 = strCmd1.Replace(Chr(34), Chr(34) + " + (char)34 + " + Chr(34))
            End If
        End If


        If strCmd1.Length > 100 Then
            For i As Integer = 0 To System.Math.Round(strCmd1.Length / 50) - 1
                If strCmd1.Contains(Chr(34)) Then
                    iLength = strCmd1.IndexOf(" + (char)34 + ", iLength + 1) + 12
                    strCmd2 += strCmd1.Substring(iStart, iLength - iStart + 1) + Chr(13) + Chr(10)
                    iStart = iLength + 1
                    iLength += 50
                Else
                    iLength = strCmd1.IndexOf(Chr(32), iLength + 1)
                    strCmd2 += strCmd1.Substring(iStart, iLength - iStart + 1) + Chr(34) + " + " _
                     + Chr(13) + Chr(10) + Chr(34)
                    iStart = iLength + 1
                    iLength += 50
                End If

                If strCmd1.Length - iLength <= 50 Then
                    If strCmd1.EndsWith("(char)34") Then
                        strCmd2 += strCmd1.Substring(iStart, strCmd1.Length - iStart) + ";"
                    Else
                        strCmd2 += strCmd1.Substring(iStart, strCmd1.Length - iStart) + Chr(34) + ";"
                    End If
                    Exit For
                End If
            Next
        Else
            If strCmd1.EndsWith("(char)34") Then
                strCmd2 = strCmd1 + ";"
            Else
                strCmd2 = strCmd1 + Chr(34) + ";"
            End If
        End If
        Return strCmd2

    End Function
End Class
